#ifndef __LKM
/*
 Loadable Kernel Module definition module
*/
#define __LKM
#include "..\\kernel.hpp"
#include "..\\dlcl\\3osdlcl.hpp"
#include "..\\ctype.hpp"

extern c_Kernel  *pc_Krnl3OS;

typedef void (*fLKMStart)(fClassLink, void* vBaseLKM);
#pragma pack(1);
class c_LKM
{
 protected:
   dword     dwSignature;
   fLKMStart vStart;
   dword     size;
 public:
  c_LKM(void) {};
  ~c_LKM()    {};

  bool IsLKM(void)                   {return (bool)(dwSignature == 'LKM ');};
  void Start(fClassLink vClassLink)
  {
   vStart = (fLKMStart) ((dword) vStart + (dword) this);
   vStart(vClassLink, (char*)this);
  };
};
#pragma pack(0);
#endif