/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
#include "..\\ctype.hpp"

#define m_OutText(X,Y,TEXT) m_putxy(Y<<8|X,sizeof(TEXT),TEXT)

extern void m_putxy(word xy,word size_text,void* addr_text);
#pragma aux m_putxy = \
"pusha"              \
"mov bp, ax"         \
"mov ax, 0x1300"     \
"mov bx, 0x0012"     \
"int 0x10"           \
"popa"               \
modify [bp bx]       \
parm [dx][cx][ax];

extern void m_calibrate_disk(byte disk_id);
#pragma aux m_calibrate_disk = \
"mov ah, 0x00" \
"int 0x13"     \
modify [ax]    \
parm[dl];

extern void m_read_sectors(byte nSector, word tracksector, word headdrive, void near *offset);
#pragma aux m_read_sectors = \
"push cs"        \
"pop  es"        \
"mov ah, 0x02"   \
"int 0x13"       \
parm [al][cx][dx][bx];

char buffer[4096];

void main_module(void)
{
#pragma aux main_module modify [ax bx cx dx si di];
 m_OutText(10,10,"V8086 start thread");
 m_calibrate_disk(1);
 m_read_sectors(4,1<<8|2,1<<8|1,&buffer[0]);
 while(1);
}