/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
// revised: 02-07-2004 00:27:51

#ifndef  __KEYBOARD
#define  __KEYBOARD

const byte k_Read   = 0xD0;
const byte k_Write  = 0xD1;

extern byte m_KbdState_Get(void);
extern byte m_KbdData_Get(void);
extern void m_KbdState_Set(byte value);
extern void m_KbdData_Set(byte value);
extern void m_IO_delay(void);

#pragma aux m_KbdState_Get = "in al, 0x64"  value [al];
#pragma aux m_KbdState_Set = "out 0x64, al" parm [al];
#pragma aux m_KbdData_Get  = "in al, 0x60"  value [al];
#pragma aux m_KbdData_Set  = "out 0x60, al" parm [al];
#pragma aux m_IO_delay     = "jmp m1""m1:";

#endif  /* __KEYBOARD */
