/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
#ifndef __MEM
/*
-----------------------------------------------------------------------------
 == Kernel 3OS module definition ==
  ।  ᮢ  ࠡ  
-----------------------------------------------------------------------------
*/
#define __MEM

/* 楤 ஢  */
extern "C" void __cdecl memmove(void *__s1, const void *__s2, size_t __n);
extern "C" void __cdecl memcpy(void *__s1, const void *__s2, size_t __n);

#ifndef __CODE16

/* ஢ 묨 ᫮ */
extern void dwCopy(void *vTarget, void *vSource, dword QnDword);
#pragma aux dwCopy = \
"rep  movsd"   \
modify[edi esi ecx] \
parm [edi][esi][ecx] ;


/*
 楤 ஢  쭮 ࠭⢠  쭮
  vTarget - local target, dwGlbAddrSrc - global source
  esi <- vTarget
  edi <- dwGlbAddrSrc
  es:edi <- ds:esi
*/
extern void m_DwordFlatCopy(void *vTarget, dword dwGlbAddrSrc, dword Size);
#pragma aux m_DwordFlatCopy = \
  "push fs"     \
  "pop  ds"     \
  "shr  ecx, 2" \
  "rep movsd"   \
  "nop "        \
  "push es"     \
  "pop  ds"     \
modify[esi edi ecx] \
parm [edi][esi][ecx];

extern void m_FlatCopy(void* vSrc, void* vTarg, dword Size);
#pragma aux m_FlatCopy = \
"next:"             \
"mov al, ds:[edi]"  \
"mov fs:[esi], al"  \
"inc edi"           \
"inc esi"           \
"loop next"         \
modify[al] \
parm[esi][edi][ecx];

/* 楤 ⥭  ⥪ ࠬ஢ */
extern dword ByteParam(char *par_ss_addr);
#pragma aux ByteParam = \
"xor edx, edx" \
"mov dl, byte ptr SS:[edx]" \
parm [edx] \
value [edx] \
modify [edx];

extern dword WordParam(char *par_ss_addr);
#pragma aux WordParam = \
"xor edx, edx" \
"mov dx, word ptr SS:[edx]" \
parm [edx] \
value [edx] \
modify [edx];

extern dword DwordParam(char *par_ss_addr);
#pragma aux DwordParam = \
"mov edx, dword ptr SS:[edx]" \
parm [edx] \
value [edx] \
modify [edx];

#endif

#endif