/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 16 ࠧ來 "⮢  30S"
*/
#define __CODE16

#include "start16.hpp"
#include "hardware.hpp"
#include "macro.h"
#include "descript.hpp"
#include "vesainfo.h"

extern s_DVector GDT[5];

s_VrGDTR s_VGDTR = {1, 1}; // 樠 
char text[16] = "3OS>  Real mode";

#pragma pack(16)           // ⠭ ࠢ  ࠣ (=16 )
/*  GDT ࠭ ⮢  ᥣ DATA   ⠭ */
s_DVector GDT[5] = {
//==>  ન - !!! 易⥫  0  GDT
 {0,0},
//==> ਯ ࠭⢠   {precacl size = 64K}
 m_DATA_DESCRIPTOR(0x0FFFF, 0x0, k_RAM, k_KLvl, k_ERCode, k_1Bt, k_D32),
//==> ਯ ࠭⢠  
 m_DATA_DESCRIPTOR(0xFFFFF, 0x0, k_RAM, k_KLvl, k_RWDataUp, k_4Kb, k_D32),
//==> ਯ ࠭⢠   (⥪) - ।⥫
 m_DATA_DESCRIPTOR(0x0, 0x0, k_RAM, k_KLvl, k_RWDataUp, k_1Bt, k_D32),
//==> ਯ ࠭⢠  - ᪮ 4 ᭮ -
 m_DATA_DESCRIPTOR(0xFFFFF, 0x0, k_RAM, k_KLvl, k_RWDataUp, k_4Kb, k_D32)
};
#pragma pack(0)            // ⠭ ।饥 祭 ࠢ


void os_main(void){
 m_Init(); /* 樠 ᥣ⮢ */
/* 樠 ਯ஢  (  )  ᮬ */
 word KernelBA = m_GlobalAddrGet(GDT[5]);
  ((s_DSpace*) &GDT[1])->wBase_I  = KernelBA;
  ((s_DSpace*) &GDT[2])->wBase_I  = KernelBA;

 /* 뢠  0  ࠧ ᥣ ⥪ ⮦ ⠥ */
 word StackLimit = KernelBA - sizeof(GDT) + 1;
  ((s_DSpace*) &GDT[3])->wLimit   = StackLimit;

 m_CLS();
 m_OutText(60, 0, text);

 CVesaInfo *info;
 info = new CVesaInfo();
 info->GetVESAInfo();
 
 if (info->isVesaSignatureOK()==VESA_OK)
	m_OutText(60, 15, text);

 m_interrupt_AllOff();
 s_VGDTR.Set((void*)(m_GlobalAddrGet(GDT[0])), sizeof(GDT));
 m_LoadGDTR(s_VGDTR);
 m_SetPM();
 m_SegFarJmp(KernelBA, StackLimit-1); // 室    ᮬ ஢
}

