/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
// revised: 09-26-2003 00:01:27
#include "stream.hpp"
#include "ctype.hpp"

c_Stream::c_Stream(s_Stream *ps_Stream){

   dwSize = ps_Stream->Size;
   vStart = (void*) ps_Stream;
   vPos   = (char*) &(ps_Stream->aContainer);
}

dword c_Stream::Seek(int dwOffs, e_SeekMode e_mode){
 register byte
  *start = (char*) vStart,
  *tmp   = vPos;

 if(e_mode == k_FromStart) tmp = start;
 if(e_mode == k_FromEnd)   tmp += dwSize;

 tmp += dwOffs;

 if(tmp <= start)
  tmp = start;
 else{
  register char *end = (char*) End_Get();
  if(tmp >= end) tmp = end;
 }

 vPos = tmp;
 return (dword)(tmp - start);
}