/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
#ifndef _STRINGS
/*
 3OS Kernel definition module of STRING
*/
#define _STRINGS
#include "ctype.hpp"

extern char strcmp(char *string1, const char *string2);
/* Compares two 0 terminating strings. */
#pragma aux strcmp=\
"dec ebx" \
"top: inc ebx" \
"lodsb" \
"cmp al,0"\
"je here"\
"cmp byte ptr[bx],al"\
"je top"\
"here: sub al, byte ptr[bx]"\
parm [esi][ebx];
#endif