/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
//******************************************************************************
// ᪨ 
//******************************************************************************
class c_SModule
{
 public:
    int Test1 (int data);
    void Test2 (void);
    void Test3 (void);
};      


//******************************************************************************
//  ⮤
//******************************************************************************
int c_SModule::Test1(int data){ return 0;};
void c_SModule::Test2(void){};
void c_SModule::Test3(void){};


//******************************************************************************
// "㠫"  
//******************************************************************************
class c_VModule:public c_SModule 
{
 public:
    virtual int Test1 (int data);
    virtual void Test2 (void);
    virtual void Test3 (void);
};      


//******************************************************************************
// ⪨  맮 ॠ ⮤
//******************************************************************************
int c_VModule::Test1(int data){
    return c_SModule::Test1(data);
};

void c_VModule::Test2(void){
    c_SModule::Test2();
};

void c_VModule::Test3(void){
    c_SModule::Test3();
};


//******************************************************************************
// Exaple
//******************************************************************************
void func(void){
    volatile int i;

    c_SModule* STAT = new c_SModule;
    c_VModule* LKM  = new c_VModule;

    i = STAT->Test1(123);
    STAT->Test2();
    STAT->Test3();

    i = LKM->Test1(123);
    LKM->Test2();
    LKM->Test3();
}

