/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 === 3OS Kernel module descriptors class ==
   ਯ஢
*/
#include "CONF3OS.H"
#include "ctype.hpp"
#include "descript.hpp"
#include "kernel.hpp"
extern c_Kernel *pc_Krnl3OS;

dword c_Descriptor::Selector_Get(void){
  return pc_Krnl3OS->pc_GDT->Selector(this);
};

void* c_Descriptor::operator new(size_t){
  return (void*) pc_Krnl3OS->pc_GDT->DAlloc();
};

void c_Descriptor::Addr16(void){
 register s_ExtType *s_EType = (s_ExtType*) &(s_SysObj.bAttr);

 if(s_EType->IsSystem()) s_EType->SysType_Get().Addr16();
  else ((s_DSpcLimit*) &s_Vector.dwVec_II)->Addr16();
}

void c_Descriptor::Addr32(void){
 register s_ExtType *s_EType = (s_ExtType*) &(s_SysObj.bAttr);

  if(s_EType->IsSystem()){
   register e_SysType e_DSys = s_EType->SysType_Get().Get();
   if((e_DSys != k_LDT) && (e_DSys != k_TaskGate)) s_EType->SysType_Get().Addr32();
  }
  else ((s_DSpcLimit*) &s_Vector.dwVec_II)->Addr32();
}

/*
  ===  ਯ ࠭⢠ 饣   ===
  s_ExtType - ७ ⨯ ਯ ࠭祭 ஬  ⨯
              ࠭   ⥬ ꥪ⮬ TSS
*/
c_DSpace::c_DSpace(void *vBase, s_DSpcLimit s_Lim, s_ExtType s_Type, e_DPLevel e_Lvl)
 : c_Descriptor(e_Lvl, s_Type, k_RAM)
{
 #define p_Lim ((s_DSpcLimit*)&s_Lim)
  s_Vector.dwVec_I  = (((dword)vBase)<<16) | p_Lim->LimitI_Get();
  s_Vector.dwVec_II |= m_Expand_ROR(vBase) | (p_Lim->LimitII_Get()<<16);
 #undef p_Lim
};


