/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 Interrupts and exceptions events Kernel definition module
       
 last update: 20.02.2004 - 18:00
*/
#ifndef __IEVENTS
#define __IEVENTS
#include "ctype.hpp"

#pragma aux IntR "*" parm caller reverse [] aborts; 
extern void __pragma("IntR") _UD(dword p1, dword p2);           //  #UD
extern void __pragma("IntR") _DF(dword ERROR);           //  #DF
extern void __pragma("IntR") _NP(dword ERROR);           //  #NP
extern void __pragma("IntR") _GP(dword ERROR);           //  #GP
extern void __pragma("IntR") _SS(dword ERROR);           //  #SS
extern void __pragma("IntR") _PF(dword ERROR);           //  #PF
extern void __pragma("IntR") _ICorruption(dword ERROR);  //   #PF
extern void __pragma("IntR") _ILoop(dword ERROR);        //         


extern void __declspec(naked) _Interrupt_0E(void);   // / 0x06
extern void __declspec(naked) _Interrupt_10(void);   // / 0x10
extern void __declspec(naked) _Interrupt_13(void);   // / 0x13
extern void __declspec(naked) _Interrupt_20(void);   // / 0x20


extern void _ITimer(void);


extern void push_int(void);
#pragma aux push_int = \
"pushad"  \
"push ds" \
"push es" \
"push fs";

extern void pop_int(void);
#pragma aux pop_int = \
"pop fs" \
"pop es" \
"pop ds" \
"popad";

extern void Int_ret(void);
#pragma aux Int_ret = \
"iretd";


#endif