/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
 ----------------------------------------------------------------------------
 === 3OS Kernel startup module ===
 ⮢    32 ࠧ來 饭 ०
 ----------------------------------------------------------------------------
*/

#include "CONF3OS.H"
#include "heap.hpp"
#include "kernel.hpp"
#include "dlcl\3osdlcl.hpp"

extern void StartKernel(void *vKeStart, void *vStartUpBin);

#pragma pack(1)
/* ਬ ⮪  -㧪 */
char KrnlStream[84];
/* ᮪ Loadable Kernel Module */
char LKM_example[132];
char v86[65];

/*   */
c_Kernel *pc_Krnl3OS;

s_DLCL DLCLStorage[2]=
{
 {'LNRK',  NULL},
 {'TUOC',  NULL}
};

/*  ""  */
THeap *pc_Heap;
s_Jmp_Far jmp_up_1Mb = {0xEA, (dword)&StartKernel, (word) k_GDKrnlUpCode};

extern void m_Jmp_kernel(dword vBase, dword vBinPack, void *addr_jmp);
#pragma aux m_Jmp_kernel = "jmp EDX" parm [EAX][EBX][EDX];

/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
   ⮢  樠樨   PM,
   ਭ:
      AX    砫 ࠭⢠ 
      BX    ࠧ饭 ࠭ ⥪ 
      ECX 32 -  ᬥ饭 -
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
void StartPM(word kernel, word stack, dword BinPack)
{
#pragma aux StartPM parm [eax ebx ecx] modify [edx esi edi]; //  㦥  
   SETSEG(DS, k_GDKrnlData);             //     < 1Mb
   register dword *ke_start = (dword*) 0x0;


   while(ke_start <= (dword*) &pc_Heap)  // ॡ᪠ ࠧ   1Mb
   {
    *(dword*)((dword)ke_start + 0x100000) = *ke_start;
    ke_start ++;
   }

   SETSEG(SS, k_GDKrnlStack);     // ⥪    < 1Mb
   SETESP((dword) stack); 
   m_Jmp_kernel((dword) kernel + 0x000100000, BinPack, &jmp_up_1Mb);
}

void StartKernel(void *vKeStart, void *vStartUpBin){
#pragma aux StartKernel parm [eax ebx] modify [ecx edx esi edi];
   SETSEG(DS, k_GDKrnlUpDate);    //  
   SETSEG(ES, k_GDKrnlUpDate);    //  
   SETSEG(FS, k_GDKrnlFlat);      // 4Gb ᥣ 
   SETSEG(GS, k_GDKrnlVideo);     // -

//===> 樠 ""       ꥪ c_Heap
   pc_Heap = (THeap*) ((dword) &pc_Heap + sizeof(pc_Heap));
   pc_Heap->Init((void*)((dword)pc_Heap+sizeof(THeap)), 0x00800000);

   pc_Krnl3OS = new c_Kernel(vKeStart);
   pc_Krnl3OS->Stabilize(vStartUpBin);
}