/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
/*
  == 3OS Kernel module system out (allarm out) ==
    ਩ 뢮 ଠ樨  ࠭
*/
#include "CONF3OS.H"
#include "ctype.hpp"
#include "mem.hpp"
#include "heap.hpp"
#include "sysout.hpp"
#include "dlcl\3osdlcl.hpp"

extern s_DLCL DLCLStorage[2];

union WChar{
 word W;
 byte B;
};

c_Out::c_Out(void *vVideo)
{
 vVideoBuffer = NULL; //((void*) (0xB8000 - (dword) vVideo));
 last_offs = (word*) vVideoBuffer;

 _OUT_ = new s_dlclOUT;
 register s_dlclOUT *ps_Out = _OUT_;
 register u_dlcl *p_m_tmp = new u_dlcl;

 p_m_tmp->cls.metod = &c_Out::cls;
 ps_Out->vCLS    = p_m_tmp->cls.addr();

 p_m_tmp->puts.metod = &c_Out::puts;
 ps_Out->vPuts   = p_m_tmp->puts.addr();

 p_m_tmp->printf.metod = &c_Out::printf;
 ps_Out->vPrintf   = p_m_tmp->printf.addr();

 p_m_tmp->gotoxy.metod = &c_Out::gotoxy;
 ps_Out->vGotoXY   = p_m_tmp->gotoxy.addr();

 DLCLStorage[CLASS_OUT].vObject = this;
}

void c_Out::cls(void){
 register dword *p = (dword*) vVideoBuffer;
 last_offs = (word*)p;
 register dword *stop = p + 25*80/2;
 for(;p < stop; p++) *p = 0x0;
}

void c_Out::puts(const char *text){
 register word *p = last_offs;

 {
 register char *newtext = (char*)text;
 register union WChar cscr;
 cscr.W = 0x0700;

 while((cscr.B = *newtext++)!=NULL){

  const dword CharFromLine = 160;
  switch(cscr.B){
   case '\n':
     p += CharFromLine/2;
    continue;
   case '\r':  /* । ⭮ p 160 */;
     p =(word*)((( ((dword) p - (dword)vVideoBuffer) / CharFromLine)*CharFromLine) + (dword)vVideoBuffer);
    continue;
   case '\001':
    cscr.B = *newtext;
    cscr.W <<= 8;
    newtext++;
  }
  /* ⮩ 뢮 ᨬ  梥⮬ */;
  set_es_word((void*)p++, cscr.W);
 }}

 last_offs = p;
}

void VoidToHEX(const char *tmp, dword addr, dword size_type){
 register dword val = addr;
 register dword swap;
 register char *ptr = (char*)((dword)tmp + (size_type<<1));
 while(ptr > tmp){
  swap = (val & 0x0000000F) + (dword) '0';
  if(swap > 0x39) swap += 0x07;
  *ptr = (char) swap;
  val >>= 4;
  ptr--;
 }
}


/*
 ᯥ䨪 ଠ஢:
  %d
  %w
  %b
*/
#define MIN_BUFF 120    // 쭮 - ᨬ 室 ப

void __cdecl c_Out::printf(const char *format, ...){
 char *tmp, *start;
 char *out = new char[MIN_BUFF];
 dword len;
 register char *ptr = (char*)format;
 register char *addr =(char*)&format+4;

 /*  ᯥ䨪஢ ଠ஢   ᯨ᪠ ࠬ஢*/
  tmp = out;
  start = ptr;
  while(*ptr){
   if(*ptr == '%'){
    len = (dword)ptr - (dword)start;
    memcpy(tmp, start, len);
    tmp += (len-1);
    switch (*++ptr){
     case 'b':
       //VoidToHEX(tmp, ByteParam(addr), 1);
       VoidToHEX(tmp, DwordParam(addr), sizeof(byte));
       addr += 4;//addr++;
       tmp+=3;
      break;//continue;
     case 'w':
       //VoidToHEX(tmp, WordParam(addr), 2);
       VoidToHEX(tmp, DwordParam(addr), sizeof(word));
       addr += 4;//addr += 2;
       tmp+=5;
      break;//continue;
     case 'd':
       //VoidToHEX(tmp, DwordParam(addr), 4);
       VoidToHEX(tmp, DwordParam(addr), sizeof(dword));
       addr += 4;
       tmp+=9;
      break;
    }
    start = ptr + 1;
   }
   ptr++;
  }

 if((len = (dword)ptr - (dword)start) > 0){
  memcpy(tmp, start, len);
  tmp += (len-1);
 }
 *++tmp = 0x0;
 puts(out);
 delete(out);
}
