/*
 *  Copyright (C) 2002-2004 Aleksey Sugonyaev & 3OS.Team ( http://www.3os.ru/ )
 *  Licensed under the terms and conditions of the GNU Lesser General Public License
 */
// 3OS Vesa module
// last update 10.12.03

#include "vesainfo.hpp"

CVesaInfo::CVesaInfo()
{
}

CVesaInfo::~CVesaInfo()
{
}

int CVesaInfo::GetVESAInfo()
{
        char far *VbeInfo = (char far *)&info;
        us regdi = (us)FP_OFF(VbeInfo);
        us reges = (us)FP_SEG(VbeInfo);
        _asm {
                push es
                pusha
                mov ax, reges
                mov di, regdi
                mov es, ax
                mov ax, 0x4F00
                int 0x10
                popa
                pop es
        } 

        return VESA_OK;
}

uc CVesaInfo::isVesaSignatureOK()
{
        uc rez;
        
        if (info.VbeSignature[0]=='V' && info.VbeSignature[1]=='E' 
                && info.VbeSignature[2]=='S' && info.VbeSignature[3]=='A')
                rez = VESA_OK;
        else
                rez = VESA_ERROR;
        
        return rez;
}